#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Run_AU3Check=n
#AutoIt3Wrapper_Tidy_Stop_OnError=n
#AutoIt3Wrapper_Run_Au3Stripper=y
;~ #Au3Stripper_Parameters=/rm
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include "OnDebugMsgBox.au3"
#include <Array.au3>


If StringInStr($CmdLineRaw, "/ErrorStdOut") Then Exit MsgBox(0, @ScriptName, _
		"..the editor would catch the error." & @CR & @CR & _
		"To test this please run from explorer, command line, or compile it.", 60)


DebugMsgBox_ExampleHandler() ; this should run on another script,
;								or the same script if you are careful.


If _DebugMsgBox_AddHookApiError() Then Exit MsgBox(0, @ScriptName, "The hook failed to take. Will not catch the Window.", 60)
;									I would not use this function. But it exists and is showcased here.


_DebugMsgBox_PriorLogSize(1) ; will make the log file 1k for this example
;								you can, and I advise, leave it default ( 100k should be enough )


;~ _DebugMsgBox_ErrReportApp("OnDebugMsgBox_FakeHandler.au3")
_DebugMsgBox_ErrReportApp(@ScriptFullPath) ; this is where you declare the "On code error" handler,
;											if you happen to code some error repoting app.


_DebugMsgBox_NoMsgbox(False)         ; change at will. Default is FALSE ( meaning: do show the popup )
_DebugMsgBox_NoEventLog(False)       ; change at will. Default is FALSE ( meaning: do log to "Event Log").


_DebugMsgBox_Extra('Use it at will. Maybe some "extra" info you care to have.')
; 									this is not needed but if you'd like more info., this is here.

Example()
Func Example($var1 = Default, $var2 = 0)

	; this is not needed but if you'd like more info., this is here.
	_DebugMsgBox_FuncParams(FuncName(Example) & '(' & $var1 & ', ' & $var2 & '). Use it at will.')

	Local $aTest[5]
	$aTest[50] = "" ; oops, here is the error in my awesome script

EndFunc   ;==>Example


#Region handler

Func DebugMsgBox_ExampleHandler()
	For $n = 1 To $CmdLine[0] - 2
		If $CmdLine[$n] = "/OnDebugMsgBox" Then Exit OnDebugMsgBox_DoThis($CmdLine[$n + 1], $CmdLine[$n + 2])
	Next
EndFunc   ;==>DebugMsgBox_ExampleHandler

Func OnDebugMsgBox_DoThis($file, $timestamp)
	Local $s = FileRead($file)
	Local $b, $a = StringSplit($s, '--- start of OnDebugMsgBox report ---', 1)
	For $n = 1 To $a[0]
		If StringInStr($a[$n], $timestamp) Then

			$a[$n] = '--- start of OnDebugMsgBox report ---' & StringTrimRight($a[$n], 3)

			$b = StringSplit($a[$n], @TAB & @CRLF, 3)
			_ArrayDisplay($b, "OnDebugMsgBox_DoThis as ARRAY")

			MsgBox(0, "OnDebugMsgBox_DoThis as TEXT", $a[$n])

			; this part is up to you.
			; this is just for this example

			Return 0
		EndIf
	Next
	Return SetError(1, 0, 3)
EndFunc   ;==>OnDebugMsgBox_DoThis

#EndRegion handler
